package com.csm.huahai.web.controller;

import com.csm.huahai.common.core.controller.BaseController;
import com.csm.huahai.common.core.controller.domain.AjaxResult;
import com.csm.huahai.common.core.page.TableDataInfo;
import com.csm.huahai.common.utils.poi.ExcelUtil;
import com.csm.huahai.web.dto.*;
import com.csm.huahai.web.entity.CsmEntity;
import com.csm.huahai.web.entity.ScanCodeRecordEntity;
import com.csm.huahai.web.service.CsmService;
import com.github.pagehelper.PageHelper;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpStatus;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletResponse;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * 场所码
 *
 * @author taoyuan
 */
@RestController
@RequestMapping("/csm")
public class CsmController extends BaseController {

    @Autowired
    CsmService csmService;

    @PostMapping("/getCsmList")
    public TableDataInfo getCsmList(@RequestBody CsmQueryVo csmQueryVo) {
        PageHelper.startPage(csmQueryVo.getPageNum(), csmQueryVo.getPageSize(), "").setReasonable(true);
        List<CsmDto> csmList = csmService.getCsmList(csmQueryVo.getTechnologyName());
        return getDataTable(csmList);
    }

    @PostMapping("/getDdSelect")
    public TableDataInfo getDdSelect(@RequestBody DdSelectDto ddSelectDto ) {
        PageHelper.startPage(ddSelectDto.getPageNum(), ddSelectDto.getPageSize(), "").setReasonable(true);
        List<CsddDto> ddSelect = csmService.getDdSelect(ddSelectDto.getTechnologyName());
        return getDataTable(ddSelect);
    }

    @PostMapping("/saveCsm")
    public AjaxResult saveCsm(@RequestBody CsmEntity csmEntity ) {
        int csmNum = csmService.getCsmNum(csmEntity.getBzdzbm());
        if(csmNum>0){
            return AjaxResult.error("该场所编码已被占用");
        }else{
            csmService.saveCsm(csmEntity);
            return AjaxResult.success(csmEntity);
        }
    }

    @PostMapping("/saveScanRecord")
    public AjaxResult saveScanRecord(@RequestBody ScanCodeRecordEntity scanCodeRecordEntity ) {
        csmService.saveScanRecord(scanCodeRecordEntity);
        return AjaxResult.success();
    }

    @PostMapping("/getCsmNum")
    public AjaxResult getCsmNum(@RequestBody QueryCsmNumDto queryCsmNumDto ) {
        return AjaxResult.success(csmService.getCsmNum(queryCsmNumDto.getBzdzbm()));
    }

    @PostMapping("/getAdressByBzdzbm")
    public AjaxResult getAdressByBzdzbm(@RequestBody QueryAdressDto queryAdressDto ) {
        return AjaxResult.success(csmService.getAdressByBzdzbm(queryAdressDto.getBzdzbm()));
    }





}
