package com.csm.huahai.web.controller;


import com.csm.huahai.common.core.controller.BaseController;
import com.csm.huahai.common.core.controller.domain.AjaxResult;
import com.csm.huahai.common.core.page.TableDataInfo;
import com.csm.huahai.web.dto.WycCheckDataDto;
import com.csm.huahai.common.utils.poi.ExcelUtil;
import com.csm.huahai.web.dto.WycCheckDto;
import com.csm.huahai.web.dto.*;
import com.csm.huahai.web.service.WycDataContrastService;
import org.apache.commons.codec.DecoderException;
import org.apache.commons.codec.binary.Hex;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;

import javax.crypto.*;
import javax.crypto.spec.IvParameterSpec;
import javax.crypto.spec.SecretKeySpec;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;
import java.io.*;
import java.nio.charset.StandardCharsets;
import java.security.InvalidAlgorithmParameterException;
import java.security.InvalidKeyException;
import java.security.NoSuchAlgorithmException;
import java.util.*;


/**
 * 网约车数据对比
 *
 * @author taoyuan
 */
@RestController
@RequestMapping("/wyc/dataContrast")
public class WycDataContrastController extends BaseController {

    @Autowired
    private WycDataContrastService wycDataContrastService;

    @PostMapping("import")
    public AjaxResult dataContrast(MultipartFile file, HttpSession session, @RequestParam("type") String type){
        try {
            ExcelUtil<WycCheckDataDto> util = new ExcelUtil<WycCheckDataDto>(WycCheckDataDto.class);
            boolean flag = util.checkHeader("",file.getInputStream(),3);
            if(!flag){
                return error("excel 格式不正确！");
            }
            List<WycCheckDataDto> list = util.importExcel(file.getInputStream(),3);
            int i = wycDataContrastService.dataContrast(list,session,type);
            if(1!=0){
                return success("导入成功，共"+list.size()+"条数据请等待！");
            }else {
                return error("导入失败");
            }
        }catch (Exception e){
            e.printStackTrace();
            return error("导入失败");
        }
    }


    @PostMapping("export")
    public void export(HttpServletResponse response,@RequestParam("pch") String pch) {
        if(pch.contains(",")){
            pch = pch.replace(",","");
        }
        List<WycCheckDataDto> wycDataCheckDetail = wycDataContrastService.getWycDataCheckDetail(pch);
        ExcelUtil<WycCheckDataDto> util = new ExcelUtil<WycCheckDataDto>(WycCheckDataDto.class);
        Map<String,String> map = new HashMap<>();
        map.put("shr","");
        map.put("shfksj","");
        util.exportExcel(response, wycDataCheckDetail, "sheet1","出租车驾驶员数据联合审核校验表",map);
    }

    @GetMapping("/list")
    public TableDataInfo list(@RequestParam("pch") String pch, @RequestParam("idCardNum")String idCardNum){
        startPage();
        List<WycCheckDto> list = wycDataContrastService.getList(pch,idCardNum);
        return getDataTable(list);
    }

    @GetMapping("/detail")
    public TableDataInfo detail(@RequestParam("pch") String pch){
        startPage();
        List<WycCheckDataDto> wycDataCheckDetail = wycDataContrastService.getWycDataCheckDetail(pch);
        return getDataTable(wycDataCheckDetail);
    }

    public static void main(String[] args) throws NoSuchAlgorithmException, BadPaddingException, IllegalBlockSizeException, NoSuchPaddingException, InvalidKeyException, InvalidAlgorithmParameterException, UnsupportedEncodingException, DecoderException {
        /*String s = "230121199604100039";
        System.out.println("原始数据："+s);
        byte[] keyBytes = "gjfj123456789012".getBytes();
        SecretKeySpec secretKey = new SecretKeySpec(keyBytes,"AES");
        System.out.println("加密秘钥"+secretKey.toString());
        Cipher cipher = Cipher.getInstance("AES");
        cipher.init(Cipher.ENCRYPT_MODE,secretKey);
        byte[] encryptedBytes = cipher.doFinal(s.getBytes());
        String s1 = Base64.getEncoder().encodeToString(encryptedBytes);
        System.out.println("加密后的数据："+s1);

        Cipher cipher1 = Cipher.getInstance("AES");
        cipher1.init(Cipher.DECRYPT_MODE,secretKey);
        byte[] decodedBytes = Base64.getDecoder().decode(s1);
        byte[] decryptedBytes = cipher1.doFinal(decodedBytes);
        System.out.println("解密后的数据："+new String(decryptedBytes));*/
        //String s = "822D32D641EBE43931D841F609939597306E9D8D3CE778C7";
        //byte[] encryptedData = s.getBytes(StandardCharsets.UTF_8);



        //byte[] encryptedData = Hex.decodeHex(s.toCharArray());
        String keyString = "TIANJINBJ0._ROW@KEY-PASSWORD8888";
        /*byte[] keyBytes = keyString.getBytes(StandardCharsets.UTF_8);
        byte[] adjustedKey = Arrays.copyOf(keyBytes,24);

        SecretKey secretKey = new SecretKeySpec(adjustedKey,"DESede");
        byte[] iv = new byte[8];
        IvParameterSpec ivSpec = new IvParameterSpec(iv);
        Cipher cipher = Cipher.getInstance("DESede/CBC/PKCS5Padding");
        cipher.init(Cipher.DECRYPT_MODE,secretKey,ivSpec);
        byte[] decryptedBytes = cipher.doFinal(encryptedData);
        System.out.println(new String(decryptedBytes,StandardCharsets.UTF_8));*/


        //////////////////////////////////////////////////
        String input = "230121199604100039";
        /*System.out.println("原始数据："+input);
        byte[] fullkey = keyString.getBytes(StandardCharsets.UTF_8);
        byte[] truncatedKey = Arrays.copyOf(fullkey,24);

        SecretKey secretKey1 = new SecretKeySpec(truncatedKey,"DESede");
        byte[] iv1 = new byte[8];
        IvParameterSpec ivParameterSpec = new IvParameterSpec(iv1);
        Cipher cipher1 = Cipher.getInstance("DESede/CBC/PKCS5Padding");
        cipher1.init(Cipher.ENCRYPT_MODE,secretKey1,ivParameterSpec);
        byte[] inputBytes = input.getBytes(StandardCharsets.UTF_8);
        byte[] result = cipher1.doFinal(inputBytes);
        StringBuilder sres = new StringBuilder();
        for(byte b:result){
            sres.append(String.format("%02X",b));
        }
        System.out.println("加密后的数据");
        System.out.println(sres);*/

        byte[] encryptedData = Hex.decodeHex(input.toString().toCharArray());
        byte[] keyBytes = keyString.getBytes(StandardCharsets.UTF_8);
        byte[] adjustedKey = Arrays.copyOf(keyBytes,24);

        SecretKey secretKey = new SecretKeySpec(adjustedKey,"DESede");
        byte[] iv = new byte[8];
        IvParameterSpec ivSpec = new IvParameterSpec(iv);
        Cipher cipher = Cipher.getInstance("DESede/CBC/PKCS5Padding");
        cipher.init(Cipher.DECRYPT_MODE,secretKey,ivSpec);
        byte[] decryptedBytes = cipher.doFinal(encryptedData);
        System.out.println("解密后的数据");
        System.out.println(new String(decryptedBytes,StandardCharsets.UTF_8));

    }

}
