package com.csm.huahai.web.controller;

import com.csm.huahai.common.core.controller.BaseController;
import com.csm.huahai.common.core.controller.domain.AjaxResult;
import com.csm.huahai.web.dto.WycTypeNumStatisticsResultDto;
import com.csm.huahai.web.service.WycStatisticsService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

/**
 * 网约车数据统计
 *
 * @author taoyuan
 */
@RestController
@RequestMapping("/wyc/statistics")
public class WycStatisticsController extends BaseController {

    @Autowired
    WycStatisticsService wycStatisticsService;

    /**
     * 获取户籍统计图
     * @param dateType
     * @return
     */
    @GetMapping("/getTypeNumStatistics")
    public AjaxResult getTypeNumStatistics(@RequestParam("dateType")String dateType){
        WycTypeNumStatisticsResultDto wycTypeNumStatisticsResultDto = wycStatisticsService.getTypeNumStatistics(dateType);
        return AjaxResult.success(wycTypeNumStatisticsResultDto);
    }

    /**
     * 获取性别统计图
     * @param dateType
     * @return
     */
    @GetMapping("/getManAndWomenNumStatistics")
    public AjaxResult getManAndWomenNumStatistics(@RequestParam("dateType")String dateType){
        WycTypeNumStatisticsResultDto wycTypeNumStatisticsResultDto = wycStatisticsService.getManAndWomenNumStatistics(dateType);
        return AjaxResult.success(wycTypeNumStatisticsResultDto);
    }

}
