package com.csm.huahai.web.dto;

import com.csm.huahai.common.annotation.Excel;
import com.fasterxml.jackson.annotation.JsonFormat;

import java.util.Date;

/**
 * 网约车审核数据
 */
public class WycCheckDataDto {

    private String id;

    /**
     * 批次号
     */
    private String pch;

    /**
     * 身份证
     */
    @Excel(name = "身份证号")
    private String idCardNum;

    /**
     * 姓名
     */
    @Excel(name = "姓名")
    private String name;

    /**
     * 联系电话
     */
    @Excel(name = "联系电话")
    private String phoneNum;

    /**
     * 驾驶证档案编号
     */
    @Excel(name = "驾驶证档案编号")
    private String driverLicenseNum;

    /**
     * 准驾车型
     */
    @Excel(name = "准驾车型")
    private String carType;

    /**
     * 驾证初次领证日期
     */
    @Excel(name = "驾证初次领证日期")
    private String driverLicenseFirstDate;

    /**
     * 身份证号是否有效
     */
    @Excel(name = "身份证号是否有效",readConverterExp="1=是,0=否")
    private String idCardNumValidFlag;

    /**
     * 姓名是否一致
     */
    @Excel(name = "姓名是否一致",readConverterExp="1=是,0=否")
    private String nameValidFlag;

    /**
     * 是否为本市户籍
     */
    @Excel(name = "是否为本市户籍",readConverterExp="1=是,0=否")
    private String citySelfDomicileValidFlag;

    /**
     * 是否申领居住证
     */
    @Excel(name = "是否申领居住证",readConverterExp="1=是,0=否")
    private String residencePermitValidFlag;

    /**
     * 驾驶证档案编号是否一致
     */
    @Excel(name = "驾驶证档案编号是否一致",readConverterExp="1=是,0=否")
    private String driverLicenseNumValidFlag;

    /**
     * 准驾车型是否一致
     */
    @Excel(name = "准驾车型是否一致",readConverterExp="1=是,0=否")
    private String carTypeValidFlag;

    /**
     * 驾驶证初次领证日期是否一致
     */
    @Excel(name = "驾驶证初领日期是否一致",readConverterExp="1=是,0=否")
    private String driverLicenseFirstDateValidFlag;

    /**
     * 交通肇事犯罪
     */
    @Excel(name = "交通肇事犯罪",readConverterExp="1=有,0=无")
    private String trafficAccidentCrime;

    /**
     * 记录
     */
    @Excel(name = "危险驾驶记录",readConverterExp="1=有,0=无")
    private String dangerousDrivingRecord;

    /**
     * 吸毒记录
     */
    @Excel(name = "吸毒记录",readConverterExp="1=有,0=无")
    private String drugTakingRecord;

    /**
     * 酒驾记录
     */
    @Excel(name = "酒驾记录",readConverterExp="1=有,0=无")
    private String drunkDrivingRecord;

    /**
     * 最近连续三个记分周期未满12分
     */
    @Excel(name = "最近连续3个记分周期未满12分",readConverterExp="1=是,0=否")
    private String threeCycleNotReachedTwelveScoreRecently;

    /**
     * 交通违法满分记录索引
     */
    @Excel(name = "交通违法满分记录索引")
    private String jtwfmfjlsy;

    /**
     * 暴力犯罪记录
     */
    @Excel(name = "暴力犯罪记录",readConverterExp="1=有,0=无")
    private String violentCrimesRecord;

    /**
     * 情况备注
     */
    @Excel(name = "情况备注")
    private String situationRemark;

    /**
     * 核查标签
     */
    @Excel(name = "核查标签")
    private String checkTag;

    /**
     * 是否涉恐重点人员
     */
    @Excel(name = "是否涉恐重点人员",readConverterExp="1=是,0=否")
    private String terrorismKeynotePeopleFlag;

    /**
     * 驾驶证状态
     */
    @Excel(name = "驾驶证状态")
    private String driverLicenseStatus;

    /**
     * 全国在逃人员检索
     */
    @Excel(name = "全国在逃人员检索")
    private String nationalFugitivePersonnelSearch;

    /**
     * 肇事肇祸精神病人检索
     */
    @Excel(name = "肇事肇祸精神病人检索")
    private String zszhMentalPatientSearch;

    /**
     * 全国违法犯罪背景索引
     */
    @Excel(name = "全国违法犯罪背景索引")
    private String nationalDelinquencyIndex;

    /**
     * 拘留所背景索引
     */
    @Excel(name = "拘留所背景索引")
    private String detentionFacilityIndex;

    /**
     * 看守所背景索引
     */
    @Excel(name = "看守所背景索引")
    private String prisonIndex;

    /**
     * 死亡注销信息
     */
    @Excel(name = "死亡注销信息")
    private String deathCancellationInformation;

    /**
     * 本年度驾驶员交通违法累计次数
     */
    @Excel(name = "本年度驾驶员交通违法累计次数")
    private String trafficViolationCountThisYear;

    /**
     * 致人死亡交通事故索引
     */
    @Excel(name = "致人死亡交通事故索引")
    private String causeDeathTrafficAccidentIndex;

    /**
     * 高危人员信息索引
     */
    @Excel(name = "高危人员信息索引")
    private String highRiskPersonnelIndex;

    /**
     * 交通肇事犯罪详情
     */
    @Excel(name = "交通肇事犯罪详情")
    private String trafficAccidentCrimeDetail;

    /**
     * 危险驾驶犯罪详情
     */
    @Excel(name = "危险驾驶犯罪详情")
    private String dangerousDrivingDetail;

    /**
     * 暴力犯罪详情
     */
    @Excel(name = "暴力犯罪详情")
    private String violentCrimesDetail;

    /**
     * 吸毒记录详情
     */
    @Excel(name = "吸毒记录详情")
    private String drugTakingRecordDetail;

    /**
     * 酒驾记录详情
     */
    @Excel(name = "酒驾记录详情")
    private String drunkDrivingRecordDetail;

    /**
     * 是否达到法定退休年龄
     */
    @Excel(name = "是否达到法定退休年龄",readConverterExp="1=是,0=否")
    private String statutoryRetirementFlag;

    /**
     * 上传日期
     */
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date scsj;

    /**
     * 审核人
     */
    private String shr;
    /**
     * 审核时间
     */
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date shsj;

    /**
     * 黑名单撤销情况
     */
    @Excel(name = "黑名单撤销情况")
    private String hmdcxqk;
    /**
     * 性别
     */
    private Integer sex;

    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    public String getPch() {
        return pch;
    }

    public void setPch(String pch) {
        this.pch = pch;
    }

    public String getIdCardNum() {
        return idCardNum;
    }

    public void setIdCardNum(String idCardNum) {
        this.idCardNum = idCardNum;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getPhoneNum() {
        return phoneNum;
    }

    public void setPhoneNum(String phoneNum) {
        this.phoneNum = phoneNum;
    }

    public String getDriverLicenseNum() {
        return driverLicenseNum;
    }

    public void setDriverLicenseNum(String driverLicenseNum) {
        this.driverLicenseNum = driverLicenseNum;
    }

    public String getCarType() {
        return carType;
    }

    public void setCarType(String carType) {
        this.carType = carType;
    }

    public String getDriverLicenseFirstDate() {
        return driverLicenseFirstDate;
    }

    public void setDriverLicenseFirstDate(String driverLicenseFirstDate) {
        this.driverLicenseFirstDate = driverLicenseFirstDate;
    }

    public String getIdCardNumValidFlag() {
        return idCardNumValidFlag;
    }

    public void setIdCardNumValidFlag(String idCardNumValidFlag) {
        this.idCardNumValidFlag = idCardNumValidFlag;
    }

    public String getNameValidFlag() {
        return nameValidFlag;
    }

    public void setNameValidFlag(String nameValidFlag) {
        this.nameValidFlag = nameValidFlag;
    }

    public String getCitySelfDomicileValidFlag() {
        return citySelfDomicileValidFlag;
    }

    public void setCitySelfDomicileValidFlag(String citySelfDomicileValidFlag) {
        this.citySelfDomicileValidFlag = citySelfDomicileValidFlag;
    }

    public String getResidencePermitValidFlag() {
        return residencePermitValidFlag;
    }

    public void setResidencePermitValidFlag(String residencePermitValidFlag) {
        this.residencePermitValidFlag = residencePermitValidFlag;
    }

    public String getDriverLicenseNumValidFlag() {
        return driverLicenseNumValidFlag;
    }

    public void setDriverLicenseNumValidFlag(String driverLicenseNumValidFlag) {
        this.driverLicenseNumValidFlag = driverLicenseNumValidFlag;
    }

    public String getCarTypeValidFlag() {
        return carTypeValidFlag;
    }

    public void setCarTypeValidFlag(String carTypeValidFlag) {
        this.carTypeValidFlag = carTypeValidFlag;
    }

    public String getDriverLicenseFirstDateValidFlag() {
        return driverLicenseFirstDateValidFlag;
    }

    public void setDriverLicenseFirstDateValidFlag(String driverLicenseFirstDateValidFlag) {
        this.driverLicenseFirstDateValidFlag = driverLicenseFirstDateValidFlag;
    }

    public String getTrafficAccidentCrime() {
        return trafficAccidentCrime;
    }

    public void setTrafficAccidentCrime(String trafficAccidentCrime) {
        this.trafficAccidentCrime = trafficAccidentCrime;
    }

    public String getDangerousDrivingRecord() {
        return dangerousDrivingRecord;
    }

    public void setDangerousDrivingRecord(String dangerousDrivingRecord) {
        this.dangerousDrivingRecord = dangerousDrivingRecord;
    }

    public String getDrugTakingRecord() {
        return drugTakingRecord;
    }

    public void setDrugTakingRecord(String drugTakingRecord) {
        this.drugTakingRecord = drugTakingRecord;
    }

    public String getDrunkDrivingRecord() {
        return drunkDrivingRecord;
    }

    public void setDrunkDrivingRecord(String drunkDrivingRecord) {
        this.drunkDrivingRecord = drunkDrivingRecord;
    }

    public String getThreeCycleNotReachedTwelveScoreRecently() {
        return threeCycleNotReachedTwelveScoreRecently;
    }

    public void setThreeCycleNotReachedTwelveScoreRecently(String threeCycleNotReachedTwelveScoreRecently) {
        this.threeCycleNotReachedTwelveScoreRecently = threeCycleNotReachedTwelveScoreRecently;
    }

    public String getViolentCrimesRecord() {
        return violentCrimesRecord;
    }

    public void setViolentCrimesRecord(String violentCrimesRecord) {
        this.violentCrimesRecord = violentCrimesRecord;
    }

    public String getSituationRemark() {
        return situationRemark;
    }

    public void setSituationRemark(String situationRemark) {
        this.situationRemark = situationRemark;
    }

    public String getCheckTag() {
        return checkTag;
    }

    public void setCheckTag(String checkTag) {
        this.checkTag = checkTag;
    }

    public String getTerrorismKeynotePeopleFlag() {
        return terrorismKeynotePeopleFlag;
    }

    public void setTerrorismKeynotePeopleFlag(String terrorismKeynotePeopleFlag) {
        this.terrorismKeynotePeopleFlag = terrorismKeynotePeopleFlag;
    }

    public String getDriverLicenseStatus() {
        return driverLicenseStatus;
    }

    public void setDriverLicenseStatus(String driverLicenseStatus) {
        this.driverLicenseStatus = driverLicenseStatus;
    }

    public String getNationalFugitivePersonnelSearch() {
        return nationalFugitivePersonnelSearch;
    }

    public void setNationalFugitivePersonnelSearch(String nationalFugitivePersonnelSearch) {
        this.nationalFugitivePersonnelSearch = nationalFugitivePersonnelSearch;
    }

    public String getZszhMentalPatientSearch() {
        return zszhMentalPatientSearch;
    }

    public void setZszhMentalPatientSearch(String zszhMentalPatientSearch) {
        this.zszhMentalPatientSearch = zszhMentalPatientSearch;
    }

    public String getNationalDelinquencyIndex() {
        return nationalDelinquencyIndex;
    }

    public void setNationalDelinquencyIndex(String nationalDelinquencyIndex) {
        this.nationalDelinquencyIndex = nationalDelinquencyIndex;
    }

    public String getDetentionFacilityIndex() {
        return detentionFacilityIndex;
    }

    public void setDetentionFacilityIndex(String detentionFacilityIndex) {
        this.detentionFacilityIndex = detentionFacilityIndex;
    }

    public String getPrisonIndex() {
        return prisonIndex;
    }

    public void setPrisonIndex(String prisonIndex) {
        this.prisonIndex = prisonIndex;
    }

    public String getDeathCancellationInformation() {
        return deathCancellationInformation;
    }

    public void setDeathCancellationInformation(String deathCancellationInformation) {
        this.deathCancellationInformation = deathCancellationInformation;
    }

    public String getTrafficViolationCountThisYear() {
        return trafficViolationCountThisYear;
    }

    public void setTrafficViolationCountThisYear(String trafficViolationCountThisYear) {
        this.trafficViolationCountThisYear = trafficViolationCountThisYear;
    }

    public String getCauseDeathTrafficAccidentIndex() {
        return causeDeathTrafficAccidentIndex;
    }

    public void setCauseDeathTrafficAccidentIndex(String causeDeathTrafficAccidentIndex) {
        this.causeDeathTrafficAccidentIndex = causeDeathTrafficAccidentIndex;
    }

    public String getHighRiskPersonnelIndex() {
        return highRiskPersonnelIndex;
    }

    public void setHighRiskPersonnelIndex(String highRiskPersonnelIndex) {
        this.highRiskPersonnelIndex = highRiskPersonnelIndex;
    }

    public String getTrafficAccidentCrimeDetail() {
        return trafficAccidentCrimeDetail;
    }

    public void setTrafficAccidentCrimeDetail(String trafficAccidentCrimeDetail) {
        this.trafficAccidentCrimeDetail = trafficAccidentCrimeDetail;
    }

    public String getDangerousDrivingDetail() {
        return dangerousDrivingDetail;
    }

    public void setDangerousDrivingDetail(String dangerousDrivingDetail) {
        this.dangerousDrivingDetail = dangerousDrivingDetail;
    }

    public String getViolentCrimesDetail() {
        return violentCrimesDetail;
    }

    public void setViolentCrimesDetail(String violentCrimesDetail) {
        this.violentCrimesDetail = violentCrimesDetail;
    }

    public String getDrugTakingRecordDetail() {
        return drugTakingRecordDetail;
    }

    public void setDrugTakingRecordDetail(String drugTakingRecordDetail) {
        this.drugTakingRecordDetail = drugTakingRecordDetail;
    }

    public String getDrunkDrivingRecordDetail() {
        return drunkDrivingRecordDetail;
    }

    public void setDrunkDrivingRecordDetail(String drunkDrivingRecordDetail) {
        this.drunkDrivingRecordDetail = drunkDrivingRecordDetail;
    }

    public String getStatutoryRetirementFlag() {
        return statutoryRetirementFlag;
    }

    public void setStatutoryRetirementFlag(String statutoryRetirementFlag) {
        this.statutoryRetirementFlag = statutoryRetirementFlag;
    }

    public Date getScsj() {
        return scsj;
    }

    public void setScsj(Date scsj) {
        this.scsj = scsj;
    }

    public Integer getSex() {
        return sex;
    }

    public void setSex(Integer sex) {
        this.sex = sex;
    }

    public String getShr() {
        return shr;
    }

    public void setShr(String shr) {
        this.shr = shr;
    }

    public Date getShsj() {
        return shsj;
    }

    public void setShsj(Date shsj) {
        this.shsj = shsj;
    }

    public String getHmdcxqk() {
        return hmdcxqk;
    }

    public void setHmdcxqk(String hmdcxqk) {
        this.hmdcxqk = hmdcxqk;
    }

    public String getJtwfmfjlsy() {
        return jtwfmfjlsy;
    }

    public void setJtwfmfjlsy(String jtwfmfjlsy) {
        this.jtwfmfjlsy = jtwfmfjlsy;
    }
}
