package com.csm.huahai.web.mapper.secondmapper;

import org.apache.ibatis.annotations.Param;
import org.springframework.stereotype.Repository;

import java.util.List;
import java.util.Map;

/**
 * 驾驶相关信息
 * @author taoyuan
 * @date 2024/12/10
 */
@Repository
public interface DriverMessageMapper {

    /**
     * 驾驶证信息
     * @param idCard
     * @return
     */
    Map<String,String> getJzMessage(@Param("idCard") String idCard);

    /**
     * 交通肇事犯罪
     * @param idCard
     * @return
     */
    int getTrafficAccidentCrime(@Param("idCard")String idCard);

    /**
     * 危险记录驾驶
     * @param idCard
     * @return
     */
    int getDangerousDrivingRecord(@Param("idCard")String idCard);

    /**
     * 酒驾记录
     * @param idCard
     * @return
     */
    List<Map<String,String>> getDrunkDrivingRecord(@Param("idCard")String idCard);

    /**
     * 驾驶证状态
     * @param idCard
     * @return
     */
    String getDriverLicenseStatus(@Param("idCard")String idCard);

    /**
     * 本年度驾驶员交通违法累计次数
     * @param idCard
     * @return
     */
    String getTrafficViolationCountThisYear(@Param("idCard")String idCard,@Param("nd")String nd);

    /**
     * 查询当前是否超过12分
     * @param idCard
     * @return
     */
    Integer getCurrentNum(@Param("idCard")String idCard);

    /**
     * 获取清分历史记录表计分年度
     * @param idCard
     * @param year
     * @return
     */
    List<Integer> getPointresetNum(@Param("idCard")String idCard, @Param("year")String year);

    /**
     * 死亡信息查询
     * @param idCard
     * @return
     */
    List<Map<String, String>> getDeathMessage(@Param("idCard")String idCard);

    /**
     * 肇事肇祸精神病人检索
     * @param idCard
     * @return
     */
    String getZszhMentalPatient(@Param("idCard")String idCard);

    /**
     * 高危人员信息查询
     * @param idCard
     * @return
     */
    List<Map<String, String>> getHighRiskPersonnelIndex(@Param("idCard")String idCard);

    /**
     * 致人死亡交通事故查询
     * @param idCard
     * @return
     */
    List<Map<String, String>> getCauseDeathTrafficAccidentIndex(@Param("idCard")String idCard);

    /**
     * 获取扣分数
     * @param idCard
     * @return
     */
    List<Map<String,Integer>> getDeductPoints(@Param("idCard")String idCard,@Param("year")String year,@Param("startDate1")String startDate1,@Param("endDate1")String endDate1, @Param("startDate2")String startDate2,@Param("endDate2")String endDate2,@Param("startDate3")String startDate3,@Param("endDate3")String endDate3,@Param("startDate4")String startDate4,@Param("endDate4")String endDate4);

    List<Map<String,String>> getwfDeatil(@Param("idCard")String idCard,@Param("startTime")String startTime,@Param("endTime")String endTime);

    List<Map<String,String>> getswxx(@Param("idCard")String idCard);
}
