/*
package com.csm.huahai.web.service.System.impl;

import com.csm.huahai.web.domain.entity.SysRole;
import com.csm.huahai.web.domain.vo.MetaVo;
import com.csm.huahai.web.domain.vo.RouterVo;
import com.dragonsoft.dids.client.service.UserResourceService;
import com.dragonsoft.dids.model.AuthResult;
import com.dragonsoft.dids.model.BaseUserInfo;
import com.dragonsoft.dids.model.UserInfo;
import com.fasterxml.jackson.databind.ObjectMapper;
import com.csm.huahai.common.core.controller.domain.AjaxResult;
import com.csm.huahai.web.domain.entity.SysUser;
import com.csm.huahai.web.service.System.SystemLoginService;
import com.csm.huahai.web.service.impl.UserResourceServiceImpl;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.stereotype.Service;

import javax.servlet.http.HttpSession;
import java.util.*;

@Service
public class SystemLoginServiceImpl implements SystemLoginService {

    private static final Logger log = LoggerFactory.getLogger(SystemLoginService.class);

    private ObjectMapper objectMapper = new ObjectMapper();

    private final Map<String,String> titleMap = new HashMap<>();

    public SystemLoginServiceImpl(){
        titleMap.put("wyccheck","公交背核");
        titleMap.put("check","审核");
        titleMap.put("statistics","统计");
    }

    @Override
    public AjaxResult getInfo(HttpSession httpSession) {
        UserResourceService userResourceService = new UserResourceServiceImpl();
        userResourceService.setSession(httpSession);
        AuthResult authResult = userResourceService.getAuthResult();
        String userId = authResult.getUserId();
        UserInfo admin = userResourceService.getUserInfo(userId);
        List dutyList = userResourceService.getDutyList(userId);
        BaseUserInfo baseUserInfo = admin.getBaseUserInfo();
        SysUser user = new SysUser();
        user.setUserId(userId);
        user.setDeptId(baseUserInfo.getDeptId());
        user.setUserName(baseUserInfo.getName());
        user.setNickName(baseUserInfo.getName());
        List<SysRole> list = new ArrayList<>();
        List<Map<String,String>> duty = objectMapper.convertValue(dutyList,List.class);
        for(Map<String,String> map:duty){
            SysRole sysRole = new SysRole();
            sysRole.setDataScope("1");
            sysRole.setRoleId(map.get("id"));
            sysRole.setRoleName(map.get("name"));
            sysRole.setMenuCheckStrictly(false);
            sysRole.setDeptCheckStrictly(false);
            sysRole.setStatus("0");
            sysRole.setFlag(false);
            sysRole.isAdmin();
            list.add(sysRole);
        }
        user.setRoles(list);
        Set<String> roles = new HashSet();
        Set<String> permissions = new HashSet<>();
        permissions.add("*:*:*");
        roles.add("admin");
        AjaxResult ajax = AjaxResult.success();
        ajax.put("user", user);
        ajax.put("roles", roles);
        ajax.put("permissions", permissions);
        return ajax;
    }

    @Override
    public List<RouterVo> getRouters(HttpSession httpSession) {
        UserResourceService userResourceService = new UserResourceServiceImpl();
        userResourceService.setSession(httpSession);
        AuthResult authResult = userResourceService.getAuthResult();
        String userId = authResult.getUserId();
        List<Map<String,String>> rightList = userResourceService.getRightList(userId);
        List<Map<String,String>> list = objectMapper.convertValue(rightList,List.class);
        List<String> twoLevelIds = new ArrayList<>();
        List<RouterVo> resultList = new ArrayList<>();
        Map<String,RouterVo> routerVoMap = new HashMap<>();
        for(Map<String,String> map:list){
            String id = map.get("id");
            String url = map.get("url");
            log.info("加载的菜单："+url);
            String[] split = url.split(";");
            String icon = split[0];
            String component = split[1];
            String path = component.contains("/")?component.substring(component.indexOf("/")):component;
            String name = id.length()!=3?path.substring(1):path;
            String title = titleMap.get(name);
            RouterVo routerVo = new RouterVo();
            routerVo.setAlwaysShow(id.length()==3?true:null);
            routerVo.setHidden(false);
            routerVo.setComponent(id.length()==3?"Layout":component);
            routerVo.setName(name);
            routerVo.setPath(path);
            routerVo.setRedirect(id.length()==3?"noRedirect":null);
            if(id.length()==3){
                routerVo.setChildren(new ArrayList<>());
            }
            MetaVo metaVo = new MetaVo();
            metaVo.setIcon(icon);
            metaVo.setTitle(title);
            metaVo.setNoCache(false);
            routerVo.setMeta(metaVo);
            routerVoMap.put(id,routerVo);
            if(id.length()>3){
                twoLevelIds.add(id);
            }
        }
        for(String id:twoLevelIds){
            RouterVo childreRouter = routerVoMap.get(id);
            id = id.substring(0,3);
            RouterVo parentRouterVo = routerVoMap.get(id);
            parentRouterVo.getChildren().add(childreRouter);
        }
        for(String key:routerVoMap.keySet()){
            if(key.length()==3){
                resultList.add(routerVoMap.get(key));
            }
        }
        return resultList;
        */
/*List<RouterVo> routerVos = new ArrayList<>();
        RouterVo routerVo1 = new RouterVo();
        routerVo1.setAlwaysShow(true);
        routerVo1.setHidden(false);
        routerVo1.setComponent("Layout");
        routerVo1.setName("Wyccheck");
        routerVo1.setPath("/wyccheck");
        routerVo1.setRedirect("noRedirect");
        MetaVo metaVo1 = new MetaVo();
        metaVo1.setIcon("tree");
        metaVo1.setTitle("网约车审核");
        metaVo1.setNoCache(false);
        routerVo1.setMeta(metaVo1);
        routerVos.add(routerVo1);

        List<RouterVo> children1 = new ArrayList<>();
        RouterVo routerVoC1 = new RouterVo();
        routerVoC1.setHidden(false);
        routerVoC1.setComponent("wyccheck/check");
        routerVoC1.setName("Check");
        routerVoC1.setPath("/check");
        MetaVo metaVoC1 = new MetaVo();
        metaVoC1.setIcon("peoples");
        metaVoC1.setTitle("审核");
        metaVoC1.setNoCache(false);
        routerVoC1.setMeta(metaVoC1);
        children1.add(routerVoC1);
        routerVo1.setChildren(children1);
        return null;*//*

    }

    public static void main(String[] args) {
        String component = "wyccheck/chech";
        System.out.println(component.substring(0,3));
    }
}
*/
