package com.csm.huahai.web.service.impl;

import com.csm.huahai.common.utils.StringUtils;
import com.csm.huahai.common.utils.uuid.IdUtils;
import com.csm.huahai.web.dto.CsddDto;
import com.csm.huahai.web.dto.CsmDto;
import com.csm.huahai.web.entity.CsmEntity;
import com.csm.huahai.web.entity.ScanCodeRecordEntity;
import com.csm.huahai.web.mapper.coremapper.CsddMapper;
import com.csm.huahai.web.mapper.secondmapper.CsmMapper;
import com.csm.huahai.web.service.CsmService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.Date;
import java.util.List;

@Service
public class CsmServiceImpl implements CsmService {

    @Autowired
    CsddMapper csddMapper;

    @Autowired
    CsmMapper csmMapper;

    @Override
    public List<CsddDto> getDdSelect(String name) {
        return csddMapper.getDdSelect(name);
    }

    @Override
    public List<CsmDto> getCsmList(String name) {
        return csmMapper.getCsmList(name) ;
    }

    @Override
    public void saveCsm(CsmEntity csmEntity) {
        csmEntity.setId(IdUtils.fastSimpleUUID());
        csmEntity.setCreateTime(new Date());
        csmMapper.saveCsm(csmEntity);
    }

    @Override
    public void saveScanRecord(ScanCodeRecordEntity scanCodeRecordEntity) {
        scanCodeRecordEntity.setId(IdUtils.fastSimpleUUID());
        csmMapper.saveScanRecord(scanCodeRecordEntity);
    }

    public int getCsmNum(String bzdzbm){
        return csmMapper.getCsmNum(bzdzbm);
    }

    @Override
    public CsddDto getAdressByBzdzbm(String bzdzbm) {
        List<CsddDto> list = csddMapper.getAdressByBzdzbm(bzdzbm);
        if(StringUtils.isNotEmpty(list)){
            return list.get(0);
        }else {
            return null;
        }
    }

}
