package com.csm.huahai.web.service.impl;

import com.csm.huahai.common.constant.Constants;
import com.csm.huahai.web.mapper.coremapper.WycStatisticsMapper;
import com.csm.huahai.web.service.WycStatisticsService;
import com.csm.huahai.web.dto.WycTypeNumStatisticsDto;
import com.csm.huahai.web.dto.WycTypeNumStatisticsResultDto;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.util.CollectionUtils;

import java.time.LocalDate;
import java.util.*;
import java.util.stream.Collectors;

@Service
public class WycStatisticsServiceImpl implements WycStatisticsService {

    @Autowired
    private WycStatisticsMapper wycStatisticsMapper;

    public WycTypeNumStatisticsResultDto getTypeNumStatistics(String dateType) {
        //0近一周1近一月2近半年3近一年
        WycTypeNumStatisticsResultDto wycTypeNumStatisticsResultDto = new WycTypeNumStatisticsResultDto();
        Map<String,String> queryData = new HashMap<>();
        if("2".equals(dateType)||"3".equals(dateType)){//按月统计
            //查询本市户籍数量
            queryData.put("sfwbshj", Constants.correct);
            List<WycTypeNumStatisticsDto> ownerCityStatisticsDtos = wycStatisticsMapper.getTypeNumStatisticsByMonth("2".equals(dateType)? LocalDate.now().minusMonths(5).toString():LocalDate.now().minusMonths(11).toString(),queryData);
            List<WycTypeNumStatisticsDto> ownerCityemptyDataList = getEmptyResultListByType(dateType);
            mergeDataToEmptyList(ownerCityemptyDataList,ownerCityStatisticsDtos);
            wycTypeNumStatisticsResultDto.setOwnerCityList(ownerCityemptyDataList);
            //查询非市户籍数量
            queryData.put("sfwbshj", Constants.deny);
            List<WycTypeNumStatisticsDto> noOwnerCityStatisticsDtos = wycStatisticsMapper.getTypeNumStatisticsByMonth("0".equals(dateType)?LocalDate.now().minusMonths(5).toString():LocalDate.now().minusMonths(11).toString(),queryData);
            List<WycTypeNumStatisticsDto> noOwnerCityemptyDataList = getEmptyResultListByType(dateType);
            mergeDataToEmptyList(noOwnerCityemptyDataList,noOwnerCityStatisticsDtos);
            wycTypeNumStatisticsResultDto.setNoOwnerCityList(noOwnerCityemptyDataList);
        }else if("0".equals(dateType)||"1".equals(dateType)){//按天统计
            //查询本市户籍数量
            queryData.put("sfwbshj", Constants.correct);
            List<WycTypeNumStatisticsDto> ownerCityStatisticsDtos = wycStatisticsMapper.getTypeNumStatisticsByDay("0".equals(dateType)? LocalDate.now().minusDays(6).toString():LocalDate.now().minusDays(29).toString(),queryData);
            List<WycTypeNumStatisticsDto> ownerCityemptyDataList = getEmptyResultListByType(dateType);
            mergeDataToEmptyList(ownerCityemptyDataList,ownerCityStatisticsDtos);
            wycTypeNumStatisticsResultDto.setOwnerCityList(ownerCityemptyDataList);
            //查询非市户籍数量
            queryData.put("sfwbshj", Constants.deny);
            List<WycTypeNumStatisticsDto> noOwnerCityStatisticsDtos = wycStatisticsMapper.getTypeNumStatisticsByDay("0".equals(dateType)?LocalDate.now().minusDays(6).toString():LocalDate.now().minusDays(29).toString(),queryData);
            List<WycTypeNumStatisticsDto> noOwnerCityemptyDataList = getEmptyResultListByType(dateType);
            mergeDataToEmptyList(noOwnerCityemptyDataList,noOwnerCityStatisticsDtos);
            wycTypeNumStatisticsResultDto.setNoOwnerCityList(noOwnerCityemptyDataList);
        }else{
            //todo
        }
        return wycTypeNumStatisticsResultDto;
    }

    @Override
    public WycTypeNumStatisticsResultDto getManAndWomenNumStatistics(String dateType) {
        WycTypeNumStatisticsResultDto wycTypeNumStatisticsResultDto = new WycTypeNumStatisticsResultDto();
        Map<String,String> queryData = new HashMap<>();
        if("2".equals(dateType)||"3".equals(dateType)){//按月统计
            //查询男性数量
            queryData.put("sex", "2");
            List<WycTypeNumStatisticsDto> manStatisticsDtos = wycStatisticsMapper.getTypeNumStatisticsByMonth("2".equals(dateType)? LocalDate.now().minusMonths(5).toString():LocalDate.now().minusMonths(11).toString(),queryData);
            List<WycTypeNumStatisticsDto> manCityemptyDataList = getEmptyResultListByType(dateType);
            mergeDataToEmptyList(manCityemptyDataList,manStatisticsDtos);
            wycTypeNumStatisticsResultDto.setManList(manCityemptyDataList);
            //查询女性数量
            queryData.put("sex", "3");
            List<WycTypeNumStatisticsDto> womanCityStatisticsDtos = wycStatisticsMapper.getTypeNumStatisticsByMonth("2".equals(dateType)?LocalDate.now().minusMonths(5).toString():LocalDate.now().minusMonths(11).toString(),queryData);
            List<WycTypeNumStatisticsDto> womanCityemptyDataList = getEmptyResultListByType(dateType);
            mergeDataToEmptyList(womanCityemptyDataList,womanCityStatisticsDtos);
            wycTypeNumStatisticsResultDto.setWomanList(womanCityemptyDataList);
        }else if("0".equals(dateType)||"1".equals(dateType)){//按天统计
            //查询男性数量
            queryData.put("sex", "2");
            List<WycTypeNumStatisticsDto> manStatisticsDtos = wycStatisticsMapper.getTypeNumStatisticsByDay("0".equals(dateType)? LocalDate.now().minusDays(6).toString():LocalDate.now().minusDays(29).toString(),queryData);
            List<WycTypeNumStatisticsDto> manCityemptyDataList = getEmptyResultListByType(dateType);
            mergeDataToEmptyList(manCityemptyDataList,manStatisticsDtos);
            wycTypeNumStatisticsResultDto.setManList(manCityemptyDataList);
            //查询女性数量
            queryData.put("sex", "3");
            List<WycTypeNumStatisticsDto> womanCityStatisticsDtos = wycStatisticsMapper.getTypeNumStatisticsByDay("0".equals(dateType)?LocalDate.now().minusDays(6).toString():LocalDate.now().minusDays(29).toString(),queryData);
            List<WycTypeNumStatisticsDto> womanCityemptyDataList = getEmptyResultListByType(dateType);
            mergeDataToEmptyList(womanCityemptyDataList,womanCityStatisticsDtos);
            wycTypeNumStatisticsResultDto.setWomanList(womanCityemptyDataList);
        }else{
            //todo
        }
        return wycTypeNumStatisticsResultDto;
    }

    /**
     * 构建空数据集合保证数据完整性
     * @param type
     * @return
     */
    private List<WycTypeNumStatisticsDto> getEmptyResultListByType(String type){
        List<WycTypeNumStatisticsDto> emptyDataList = new ArrayList<>();
        WycTypeNumStatisticsDto wycTypeNumStatisticsDto = null;
        LocalDate nowDate = LocalDate.now();
        //每种类型需要返回的数据的长度
        Map<String,Integer> typeLengthMap = Arrays.asList(
                new AbstractMap.SimpleEntry<>("0",7),
                new AbstractMap.SimpleEntry<>("1",30),
                new AbstractMap.SimpleEntry<>("2",6),
                new AbstractMap.SimpleEntry<>("3",12)
        ).stream().collect(Collectors.toMap(Map.Entry::getKey,Map.Entry::getValue));
        Integer length = typeLengthMap.get(type);
        for(int i = length-1; i>=0; i--){
            wycTypeNumStatisticsDto = new WycTypeNumStatisticsDto();
            String startDate = null;
            if("0".equals(type)||"1".equals(type)){
                startDate = nowDate.minusDays(i).toString();
                wycTypeNumStatisticsDto.setStatisticsTimeDay(Long.valueOf(startDate.substring(8,10)));
            }else{//type 2或3 按月统计
                startDate = nowDate.minusMonths(i).toString();
            }
            wycTypeNumStatisticsDto.setStatisticsNum(0l);
            wycTypeNumStatisticsDto.setStatisticsTimeYear(Long.valueOf(startDate.substring(0,4)));
            wycTypeNumStatisticsDto.setStatisticsTimeMonth(Long.valueOf(startDate.substring(5,7)));
            emptyDataList.add(wycTypeNumStatisticsDto);
        }
        return emptyDataList;
    }

    /**
     * 将本地查询结果合并到完整的空数据集中
     * @param emptyDataList
     * @param localDataList
     * @return
     */
    private List<WycTypeNumStatisticsDto> mergeDataToEmptyList(List<WycTypeNumStatisticsDto> emptyDataList,List<WycTypeNumStatisticsDto> localDataList){
        if(CollectionUtils.isEmpty(localDataList)){
            return emptyDataList;
        }
        Map<String,WycTypeNumStatisticsDto> localMap = localDataList.stream().
                collect(Collectors.toMap(WycTypeNumStatisticsDto::getStatisticsTime,obj->obj));
        for(WycTypeNumStatisticsDto wycTypeNumStatisticsDto:emptyDataList){
            if(localMap.containsKey(wycTypeNumStatisticsDto.getStatisticsTime())){
                wycTypeNumStatisticsDto.setStatisticsNum(localMap.get(wycTypeNumStatisticsDto.getStatisticsTime()).getStatisticsNum());
            }
        }
        return emptyDataList;
    }

}
