//
// Source code recreated from a .class file by IntelliJ IDEA
// (powered by Fernflower decompiler)
//

package com.dragonsoft.dids.client.utils;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.net.URISyntaxException;
import java.net.URL;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.security.CodeSource;
import java.security.ProtectionDomain;
import java.util.Properties;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

public final class PropUtils {
    protected Log logger = LogFactory.getLog(this.getClass());
    private static String PFILE;
    private static File configFile = null;
    private long lastModifiedTime = 0L;
    private Properties props = null;
    private static PropUtils instance = new PropUtils();

    private PropUtils() {
        URL url = PropUtils.class.getClassLoader().getResource("dids-client-config.properties");
        if (url != null) {
            System.out.println("url==="+url);
            PFILE = url.getPath();
            if(PFILE.contains(".jar!")){
                if(PFILE.contains("file:")){
                    PFILE = PFILE.substring(5);
                }
                int jarIndex = PFILE.indexOf(".jar!");
                if(jarIndex !=- 1){
                    PFILE = PFILE.substring(0,jarIndex);
                    PFILE = PFILE.substring(0,PFILE.lastIndexOf("/"))+"/dids-client-config.properties";
                }
            }
            System.out.println("配置文件地址为："+PFILE);
            configFile = new File(PFILE);
            this.lastModifiedTime = configFile.lastModified();
            if (this.lastModifiedTime == 0L) {
                this.logger.info(PFILE + " 文件不存在!");
            }

            this.props = new Properties();

            try {
                this.props.load(new FileInputStream(PFILE));
            } catch (Exception var3) {
                var3.printStackTrace();
            }
        } else {
            this.logger.error("原dids-client-config.properties 文件不存在!");
        }

    }

    public static synchronized PropUtils getInstance() {
        return instance;
    }

    public String getConfigItem(String name, String defaultVal) {
        if (configFile != null) {
            long newTime = configFile.lastModified();
            if (newTime == 0L) {
                if (this.lastModifiedTime == 0L) {
                    this.logger.error(PFILE + " 文件不存在!");
                } else {
                    this.logger.error(PFILE + " 文件已被删除了!!");
                }
            } else if (newTime > this.lastModifiedTime) {
                this.props.clear();

                try {
                    this.props.load(new FileInputStream(PFILE));
                } catch (Exception var6) {
                    var6.printStackTrace();
                }
            }

            this.lastModifiedTime = newTime;
            String val = this.props.getProperty(name);
            return val == null ? defaultVal : val;
        } else {
            return null;
        }
    }

    public boolean IsNewConfigFile() {
        long newTime = 0L;
        if (configFile != null) {
            newTime = configFile.lastModified();
            if (newTime == 0L) {
                if (this.lastModifiedTime == 0L) {
                    this.logger.error(PFILE + " 文件不存在!");
                } else {
                    this.logger.error(PFILE + " 文件已被删除了!!");
                }

                return false;
            }

            if (newTime > this.lastModifiedTime) {
                this.logger.info("IsNewConfigFile---配置文件重新载入!");
                this.props.clear();

                try {
                    this.props.load(new FileInputStream(PFILE));
                } catch (Exception var4) {
                    var4.printStackTrace();
                }

                return true;
            }
        }

        return false;
    }

    public String getConfigItem(String name) {
        return this.getConfigItem(name, "");
    }

    public int getIntItem(String name, int defaultValue) {
        int result = defaultValue;

        try {
            result = Integer.parseInt(this.getConfigItem(name));
        } catch (NumberFormatException var5) {
            var5.printStackTrace();
        }

        return result;
    }

    private void initProperties() {
        PFILE = PropUtils.class.getClassLoader().getResource("dids-client-config.properties").getPath();
        configFile = new File(PFILE);
        this.lastModifiedTime = configFile.lastModified();
        if (this.lastModifiedTime == 0L) {
            this.logger.error(PFILE + " 文件不存在!");
        } else {
            this.props = new Properties();

            try {
                this.props.load(new FileInputStream(PFILE));
            } catch (Exception var2) {
                var2.printStackTrace();
            }
        }

    }

    public void loadConfigFile(File config_File) throws FileNotFoundException {
        this.logger.info("调用loadConfigFile方法进行重载配置文件!");
        if (config_File != null) {
            PFILE = config_File.getPath();
            configFile = new File(PFILE);
            if (!configFile.exists()) {
                this.logger.error(PFILE + " 文件不存在!");
                this.initProperties();
            } else {
                this.logger.info("loadConfigFile----配置文件重新载入!");
                this.props = new Properties();
                this.props.clear();

                try {
                    this.props.load(new FileInputStream(PFILE));
                } catch (Exception var3) {
                    var3.printStackTrace();
                }
            }
        } else {
            this.logger.info("调用的文件不存在，则调用默认配置文件!");
            this.initProperties();
        }
    }

    public static void main(String[] args) {
        String s = "file:/E:/workspace/IDEA/wyc-manager/wyc-admin/target/classes/dids-client-config.properties";
        if(s.startsWith("file:")){
            s = s.substring(5);
            System.out.println(s);
        }
    }
}
